cups-programs:	$(GLOBJ)rastertoprinter \
		$(GLOBJ)commandtoepson \
		$(GLOBJ)epson \
		$(GLOBJ)genppd \
		$(GLOBJ)cups-calibrate

### ----------------- CUPS Ghostscript Driver ---------------------- ###

cups_=	$(GLOBJ)gdevcups.$(OBJ) $(GLOBJ)pstoraster.$(OBJ)

cups.dev:	$(cups_) page.dev
	$(SETPDEV) cups $(cups_)

$(GLOBJ)gdevcups.$(OBJ): gdevcups.c $(PDEVH)
	$(GLCC) $(GLO_)gdevcups.$(OBJ) $(C_) $(GLSRC)gdevcups.c

$(GLOBJ)pstoraster.$(OBJ): pstoraster.c $(PDEVH)
	$(GLCC) -DCUPS_DATADIR=\"$(datadir)/cups\" \
		-DCUPS_FONTPATH=\"$(fontpath)\" \
		$(GLO_)pstoraster.$(OBJ) $(C_) $(GLSRC)pstoraster.c

### -------------------- CUPS Raster Driver ------------------------ ###

rastertoprinter_=\
	$(GLOBJ)rastertoprinter.$(OBJ) \
	$(GLOBJ)gdevstp-dither.$(OBJ) \
	$(GLOBJ)gdevstp-util.$(OBJ) \
	$(GLOBJ)gdevstp-weave.$(OBJ) \
	$(GLOBJ)gdevstp-escp2.$(OBJ) \
	$(GLOBJ)gdevstp-pcl.$(OBJ) \
	$(GLOBJ)gdevstp-canon.$(OBJ) \
	$(GLOBJ)gdevstp-ps.$(OBJ)

$(GLOBJ)rastertoprinter:	$(rastertoprinter_)
	$(GLCC) $(LDFLAGS) -o $(GLOBJ)rastertoprinter \
		$(rastertoprinter_) $(EXTRALIBS) -lm

$(GLOBJ)rastertoprinter.$(OBJ): rastertoprinter.c
	$(GLCC) $(GLO_)rastertoprinter.$(OBJ) $(C_) $(GLSRC)rastertoprinter.c

### -------------------- CUPS EPSON Drivers ------------------------ ###

$(GLOBJ)commandtoepson:	$(GLOBJ)commandtoepson.$(OBJ)
	$(GLCC) $(LDFLAGS) -o $(GLOBJ)commandtoepson \
		$(GLOBJ)commandtoepson.$(OBJ) $(EXTRALIBS)

$(GLOBJ)commandtoepson.$(OBJ) : commandtoepson.c $(PDEVH)
	$(GLCC) $(GLO_)commandtoepson.$(OBJ) $(C_) $(GLSRC)commandtoepson.c

$(GLOBJ)epson:	$(GLOBJ)epson.$(OBJ)
	$(GLCC) $(LDFLAGS) -o $(GLOBJ)epson \
		$(GLOBJ)epson.$(OBJ) $(EXTRALIBS)

$(GLOBJ)epson.$(OBJ): epson.c
	$(GLCC) $(GLO_)epson.$(OBJ) $(C_) $(GLSRC)epson.c

### --------------------- PPD File Generator ----------------------- ###

genppd_=\
	$(GLOBJ)genppd.$(OBJ) \
	$(GLOBJ)gdevstp-dither.$(OBJ) \
	$(GLOBJ)gdevstp-util.$(OBJ) \
	$(GLOBJ)gdevstp-weave.$(OBJ) \
	$(GLOBJ)gdevstp-escp2.$(OBJ) \
	$(GLOBJ)gdevstp-pcl.$(OBJ) \
	$(GLOBJ)gdevstp-canon.$(OBJ) \
	$(GLOBJ)gdevstp-ps.$(OBJ)

$(GLOBJ)genppd:	$(genppd_)
	$(GLCC) $(LDFLAGS) -o $(GLOBJ)genppd $(genppd_) $(EXTRALIBS) -lm

$(GLOBJ)genppd.$(OBJ): genppd.c
	$(GLCC) $(GLO_)genppd.$(OBJ) $(C_) $(GLSRC)genppd.c

### ------------------ CUPS Calibration Utility -------------------- ###

$(GLOBJ)cups-calibrate:	$(GLOBJ)cups-calibrate.$(OBJ)
	$(GLCC) $(LDFLAGS) -o $(GLOBJ)cups-calibrate \
		$(GLOBJ)cups-calibrate.$(OBJ) $(LIBS) -lm

$(GLOBJ)cups-calibrate.$(OBJ): cups-calibrate.c
	$(GLCC) -DCUPS_PREFIX=\"$(CUPS_PREFIX)\" \
		$(GLO_)cups-calibrate.$(OBJ) $(C_) $(GLSRC)cups-calibrate.c

### ---------------------- CUPS Installation ----------------------- ###

install-cups:
	-mkdir $(bindir)
	-mkdir $(CUPS_PREFIX)
	-mkdir $(CUPS_PREFIX)/lib
	-mkdir $(CUPS_PREFIX)/lib/cups
	-mkdir $(CUPS_PREFIX)/lib/cups/backend
	-mkdir $(CUPS_PREFIX)/lib/cups/filter
	-mkdir $(CUPS_PREFIX)/share
	-mkdir $(CUPS_PREFIX)/share/cups
	-mkdir $(CUPS_PREFIX)/share/cups/data
	-mkdir $(CUPS_PREFIX)/share/cups/model
	$(INSTALL_PROGRAM) $(GLOBJ)/commandtoepson $(CUPS_PREFIX)/lib/cups/filter
	$(INSTALL_PROGRAM) $(GLOBJ)/epson $(CUPS_PREFIX)/lib/cups/backend
	$(INSTALL_PROGRAM) $(GLOBJ)/rastertoprinter $(CUPS_PREFIX)/lib/cups/filter
	$(INSTALL_PROGRAM) $(GLOBJ)/cups-calibrate $(bindir)
	-rm -f $(CUPS_PREFIX)/lib/cups/filter/pstoraster
	ln -s ../../../bin/gs $(CUPS_PREFIX)/lib/cups/filter/pstoraster
	-rm -rf cups
	$(GLOBJ)genppd --prefix cups
	$(INSTALL_DATA) cups/*$(PPDEXT) $(CUPS_PREFIX)/share/cups/model
	$(INSTALL_DATA) cups-calibrate.ppm $(CUPS_PREFIX)/share/cups/data
	$(INSTALL_DATA) cups-profile.jpg $(CUPS_PREFIX)/share/cups/data
